#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QtSql>
#include <QMessageBox>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_pushButton_clicked()
{   // chargement du driver odbc
    db = QSqlDatabase::addDatabase("QODBC");
    // connexion  la base

    // connexion  la base
    db.setDatabaseName("Gestion_Stock");
    db.setHostName("localhost\\SQLEXPRESS");

    if(!db.open())
    {
    QMessageBox::critical(0, QObject::tr("Database Error"), db.lastError().text());
    }
    // mise  jour de l'interface pour le fun
    ui->lineEdit->clear();
    ui->lineEdit->setText("connexion tablie");
}

void MainWindow::on_pushButton_2_clicked()
{   // mise  jour de l'interface
    ui->lineEdit->clear();
    ui->lineEdit->setText("connexion ferme");
    // fermeture du driver
    db.close();

}


void MainWindow::on_pushButton_3_clicked()
{

 // creation de la requete
 QString ma_requete = "SELECT * FROM Gestion_Stock.dbo.fournisseur";
 QSqlQuery query;
 // execution de la requete
 query.exec(ma_requete);

 ui->textEdit->append("-------------------------------------");
 ui->textEdit->append("Affichage de la table Fournisseur....");
 ui->textEdit->append("-------------------------------------");

 QSqlError  erreur = query.lastError();


 if (erreur.isValid())
 {
     QSqlError *checkError= new QSqlError(query.lastError());
     QMessageBox::information(this, "", checkError->text());
 }
 else
 {

     // rcuperation resultat de la requete et affichage
     while (query.next()) {
         QString numero  = query.value(0).toString();
         QString nom  = query.value(1).toString();
         QString adresse  = query.value(2).toString();
         ui->textEdit->append(numero+" "+nom+" "+adresse);
     }

 }

}

void MainWindow::on_pushButton_4_clicked()
{
    QSqlTableModel *model;
    model = new QSqlTableModel(this, db);
    QString C = model->tableName();

    model->setTable("Gestion_Stock.dbo.article");
    model->select();

    QTableView *mm;
    mm = ui->tableView;
    delete mm->model(); // liberation memoire du precedent contenu
    mm->setModel(model);
}

void MainWindow::on_pushButton_5_clicked()
{
    QSqlTableModel *model;
    model = new QSqlTableModel(this, db);
    QString C = model->tableName();

    model->setTable("Gestion_Stock.dbo.livrer");
    model->select();

    QTableView *view = new QTableView;
    view->adjustSize();
    view->setModel(model);
    view->show();
}
